precision mediump float;
uniform vec3 uColor;    //ɫ
uniform vec3 uPosition;//λã任֮
uniform vec3 uNormal;//任֮
uniform vec3 uLightLocation;//Դλ
uniform vec3 uCamera;	//λ
uniform int isShadow;			//ӰƱ־

//λռķ
void pointLight
(
  inout vec4 ambient,//
  inout vec4 diffuse,//ɢ
  inout vec4 specular,//淴  
  in vec4 lightAmbient,//Ļ
  in vec4 lightDiffuse,//ɢ
  in vec4 lightSpecular//ľ淴
)
{
  ambient=lightAmbient;			//ֱӵóǿ  
  vec3 newNormal=normalize(uNormal);
  //ӱ㵽ʸ
  vec3 eye= normalize(uCamera-uPosition);  
  //ӱ㵽Դλõʸ
  vec3 vp = normalize(uLightLocation-uPosition);
  vec3 halfVector=normalize(vp+eye);	//ߵİ    
  float shininess=50.0;				//ֲڶȣԽСԽ⻬
  float nDotViewPosition=max(0.0,dot(newNormal,vp)); 	//vpĵ0ֵ
  diffuse=lightDiffuse*nDotViewPosition;				//ɢǿ
  float nDotViewHalfVector=dot(newNormal,halfVector);	//ĵ 
  float powerFactor=max(0.0,pow(nDotViewHalfVector,shininess)); 	//淴ǿ
  specular=lightSpecular*powerFactor;    			//㾵ǿ
}

void main()
{
   //ɫ
   vec4 baseColor = vec4(uColor,1.0);
   if(isShadow == 0){ 
   		vec4 ambient, diffuse, specular;
   		pointLight(ambient,diffuse,specular,
   				vec4(0.15,0.15,0.15,1.0),vec4(0.9,0.9,0.9,1.0),vec4(0.7,0.7,0.7,1.0));
   		//ƬԪɫֵ
   		gl_FragColor=baseColor*ambient + baseColor*diffuse + baseColor*specular;   		
   } else {//Ӱֻ뻷
   		gl_FragColor=baseColor*vec4(0.15,0.15,0.15,1.0);
   }
}